/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.14).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package com.crosswordcybersecurity.api;

import com.crosswordcybersecurity.model.SearchRequestObject;
import com.crosswordcybersecurity.model.ServerResponse;
import io.swagger.annotations.*;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.validation.Valid;
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2020-01-08T18:42:23.360-03:00[America/Recife]")
@Api(tags = {"Search"}, value = "search", description = "the search API")
public interface SearchApi {

    @ApiOperation(value = "Returns a policy", nickname = "searchPolicies", notes = "Returns a tree of policies.", response = Object.class, tags={ "Search", })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "The set of policies stored with the Policy Match.", response = Object.class),
        @ApiResponse(code = 401, message = "Unauthorised", response = ServerResponse.class),
        @ApiResponse(code = 404, message = "Not Found", response = ServerResponse.class),
        @ApiResponse(code = 500, message = "Internal Server Error", response = ServerResponse.class) })
    @RequestMapping(value = "/v1/search",
        produces = { "application/json" }, 
        consumes = { "application/json" },
        method = RequestMethod.POST)
    ResponseEntity<Object> searchPolicies(@ApiParam(value = "A Policy Match JSON object." ,required=true )  @Valid @RequestBody SearchRequestObject body);

}
